/* x_tables module for matching the IPv4/IPv6 DSCP field
 *
 * (C) 2002 Harald Welte <laforge@gnumonks.org>
 * This software is distributed under GNU GPL v2, 1991
 *
 * See RFC2474 for a description of the DSCP field within the IP Header.
 *
 * xt_dscp.h,v 1.3 2002/08/05 19:00:21 laforge Exp
*/
#ifndef _XT_DSCP_H
#define _XT_DSCP_H

#ifndef TEAMF1_CHANGES
#define TEAMF1_CHANGES
#endif /* TEAMF1_CHANGES */

#define XT_DSCP_MASK	0xfc	/* 11111100 */
#define XT_DSCP_SHIFT	2
#define XT_DSCP_MAX	0x3f	/* 00111111 */

#ifdef TEAMF1_CHANGES
#define IPT_DSCP_ACT_NONE           0
#define IPT_DSCP_ACT_MARK           1
#define IPT_DSCP_ACT_MARK_RELATED   2
#endif /* TEAMF1_CHANGES */

/* match info */
struct xt_dscp_info {
	u_int8_t dscp;
	u_int8_t invert;
#ifdef TEAMF1_CHANGES
    u_int8_t act;
	u_int8_t priority;
#endif /* TEAMF1_CHANGES */
};

#endif /* _XT_DSCP_H */
