
--wan1 commands
--
function ledW1Green () 
    os.execute("/pfrm2.0/bin/ledctrl wan1 on_green")
end

function ledW1Amber ()
    os.execute("/pfrm2.0/bin/ledctrl wan1 on_amber")
end

function ledW1Off ()
    os.execute("/pfrm2.0/bin/ledctrl wan1 off")
end

--wan2 commands
--
function ledW2Green () 
    os.execute("/pfrm2.0/bin/ledctrl wan2 on_green")
end

function ledW2Amber ()
    os.execute("/pfrm2.0/bin/ledctrl wan2 on_amber")
end

function ledW2Off ()
    os.execute("/pfrm2.0/bin/ledctrl wan2 off")
end

--dmz commands
--
function ledDmzOn()
    os.execute("/pfrm2.0/bin/ledctrl dmz on")
end
function ledDmzOff()
    os.execute("/pfrm2.0/bin/ledctrl dmz off")
end
function ledDmzBlink(pattern)
    local prefix = "/pfrm2.0/bin/ledctrl dmz blink "
    if (pattern ~= "" and pattern ~= nil) then
        prefix = prefix .. pattern[1]
    else
        printCLIError ("invalid or nil binary pattern")
        return false
    end
    os.execute(prefix)
end



--test commands
--
function ledTestOn()
    os.execute("/pfrm2.0/bin/ledctrl test on")
end
function ledTestOff()
    os.execute("/pfrm2.0/bin/ledctrl test off")
end
function ledTestBlink(pattern)
    local prefix = "/pfrm2.0/bin/ledctrl test blink "
    if (pattern ~= "" and pattern ~= nil) then
        local seq = pattern[1]
        prefix = prefix .. seq
    else
        printCLIError ("invalid or nil binary pattern")
        return false
    end
    os.execute(prefix)
end



--clean command
--
function ledClean()
    os.execute("/pfrm2.0/bin/ledctrl clean")
end


--port command
--
function ledPortInit (args)
    local portnum = args[1]
    if (portnum == nil or portnum == "" or tonumber(portnum) > 5 or tonumber(portnum) < 0) then
        printCLIError (" invalid port number ")
        return -1, {}
    else
        configRow = {}
        local prefix = "/pfrm2.0/bin/ledctrl port " .. portnum .. " "
        configRow["ledPort.actionType"] = "0"
        configRow["ledPort.commandString"] = prefix
    end
    return -1, configRow
end

function ledPortSave (configRow)
    if (configRow["ledPort.actionType"] == "0") then
        configRow["ledPort.commandString"] = configRow["ledPort.commandString"] .. "off"
    elseif (configRow["ledPort.actionType"] == "1") then
        configRow["ledPort.commandString"] = configRow["ledPort.commandString"] .. "on_green"
    elseif (configRow["ledPort.actionType"] == "2") then
        configRow["ledPort.commandString"] = configRow["ledPort.commandString"] .. "on_amber"
    elseif (configRow["ledPort.actionType"] == "" or configRow["ledPort.actionType"] == nil ) then
        printCLIError ("invalid action type")
        return false
    elseif (configRow["ledPort.actionType"] == "3" or configRow["ledPort.actionType"] == "4" ) then
        if (configRow["ledPort.blinkPattern"] == nil or configRow["ledPort.blinkPattern"] == "") then
            printCLIError ("invalid Blink pattern")
            return false
        elseif (configRow["ledPort.actionType"] == "3") then
            configRow["ledPort.commandString"] = configRow["ledPort.commandString"] .. "blink_green " .. configRow["ledPort.blinkPattern"]
        elseif (configRow["ledPort.actionType"] == "4") then
            configRow["ledPort.commandString"] = configRow["ledPort.commandString"] .. "blink_amber " .. configRow["ledPort.blinkPattern"]
        end
    elseif (configRow["ledPort.actionType"] == "5") then
        if (configRow["ledPort.blinkRate"] == "" or configRow["ledPort.blinkRate"] == nil) then
            printCLIError ("invalid blinking rate")
            return false
        else
            configRow["ledPort.commandString"] = configRow["ledPort.commandString"] .. "rate " .. configRow["ledPort.blinkRate"]
        end
    end
    os.execute(configRow["ledPort.commandString"])
end

function ledPortInputVal (configRow)
    --todo
end
