-- protocolBindingCLI.lua
-- Nikhil Kumar
-- TeamF1
-- 01/05/12
-- Modification History
-- 01may12,nik  written
-- Required Libraries

require "teamf1lualib/fwView"
require "teamf1lualib/protocolBinding"

function protocolBindingCfgInit(args)
    local configRow={}
	local rowId = args[1]
	if(rowId == nil )then
        configRow["ProtocolBinding._ROWID_"] = "-1"
        configRow["ProtocolBinding.Enabled"] = "1"
        configRow["ProtocolBinding.AddressFamily"] = "2"
        configRow["ProtocolBinding.ServiceName"] = "ANY"
		configRow["ProtocolBinding.SourceNetworkType"] = "0" --Any
		configRow["ProtocolBinding.DestinationNetworkType"] = "0" --Any
        configRow["ProtocolBinding.LocalGateway"] = "WAN1"
    else
        configRow = db.getRow("ProtocolBinding", "ProtocolBinding._ROWID_", rowId)
        if (configRow == nil) then
          	print("Row does not exist")          
           	return -1, {}
        end
        if(configRow["ProtocolBinding.SourceNetworkType"] ~= nil and configRow["ProtocolBinding.SourceNetworkType"] ~= "0" and
        configRow["ProtocolBinding.SourceNetworkType"] ~= "1" and configRow["ProtocolBinding.SourceNetworkType"] ~= "2")then
            local id = tonumber(configRow["ProtocolBinding.SourceNetworkType"]) - 2
		    local LanGroupName = db.getAttribute("LanGroup","rowid",id,"GroupName")
		    if( LanGroupName == nil )then
                local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["ProtocolBinding.SourceNetworkType"] .. " AND ipGroupType=0")
                if (ipGroupId ~= nil) then
			        configRow["ProtocolBinding.SourceNetworkType"] = ipGroupId["ipGroup.ipGroupName"]
                end
		    else
			    configRow["ProtocolBinding.SourceNetworkType"] = LanGroupName
		    end
	    end
        if(configRow["ProtocolBinding.DestinationNetworkType"] ~= nil and configRow["ProtocolBinding.DestinationNetworkType"] ~= "0" and
        configRow["ProtocolBinding.DestinationNetworkType"] ~= "1" and configRow["ProtocolBinding.DestinationNetworkType"] ~= "2")then
            local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["ProtocolBinding.DestinationNetworkType"] .. " AND ipGroupType=1")
            if (ipGroupId ~= nil) then
		        configRow["ProtocolBinding.DestinationNetworkType"] = ipGroupId["ipGroup.ipGroupName"]
            end
	    end
    end
    return configRow["ProtocolBinding._ROWID_"], configRow
end

function protocolBindingCfgInputVal(configRow)
    if ( db.getAttribute("Services","ServiceName",configRow["ProtocolBinding.ServiceName"],"ServiceName") == nil and db.getAttribute("serviceGroup","serviceGroupName",configRow["ProtocolBinding.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
	if(configRow["ProtocolBinding.SourceNetworkType"] ~= nil and configRow["ProtocolBinding.SourceNetworkType"] ~= "0" and
       configRow["ProtocolBinding.SourceNetworkType"] ~= "1" and configRow["ProtocolBinding.SourceNetworkType"] ~= "2")then
		local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["ProtocolBinding.SourceNetworkType"],"rowid")
		if( LanGroupRowId == nil )then
            local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["ProtocolBinding.SourceNetworkType"] .. "' AND ipGroupType=0")
            if (ipGroupId == nil) then
			    printCLIError("Source Network Type Does not exist.")
			    return false
            else
			    configRow["ProtocolBinding.SourceNetworkType"] = ipGroupId["ipGroup.ipGroupId"]
            end
		else
			configRow["ProtocolBinding.SourceNetworkType"] = tonumber(LanGroupRowId) +2
		end
	end
    if(configRow["ProtocolBinding.DestinationNetworkType"] ~= nil and configRow["ProtocolBinding.DestinationNetworkType"] ~= "0" and
       configRow["ProtocolBinding.DestinationNetworkType"] ~= "1" and configRow["ProtocolBinding.DestinationNetworkType"] ~= "2")then
        local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["ProtocolBinding.DestinationNetworkType"] .. "' AND ipGroupType=1")
        if (ipGroupId == nil) then
		    printCLIError("Destination Network Type not exist.")
		    return false
        else
		    configRow["ProtocolBinding.DestinationNetworkType"] = ipGroupId["ipGroup.ipGroupId"]
        end
	end
    if ( configRow["ProtocolBinding.SourceNetworkType"] == '1' or configRow["ProtocolBinding.SourceNetworkType"] == '2' ) then
		if ( configRow["ProtocolBinding.SourceNetworkStart"] == nil or  configRow["ProtocolBinding.SourceNetworkStart"] == "" or configRow["ProtocolBinding.SourceNetworkStart"] == "0.0.0.0") then
			printCLIError("Enter source_network_start_ip.")
			return false
		end
		if ( configRow["ProtocolBinding.SourceNetworkType"] == '2' and (configRow["ProtocolBinding.SourceNetworkEnd"] == nil or  configRow["ProtocolBinding.SourceNetworkEnd"] == "" or configRow["ProtocolBinding.SourceNetworkEnd"] == "0.0.0.0")) then
			printCLIError("Enter source_network_end_ip.")
			return false
		end
	end
	if (configRow["ProtocolBinding.DestinationNetworkType"] == "1" or configRow["ProtocolBinding.DestinationNetworkType"] == "2" )then
		if ( configRow["ProtocolBinding.DestinationNetworkStart"] == nil or  configRow["ProtocolBinding.DestinationNetworkStart"] == ""or configRow["ProtocolBinding.DestinationNetworkStart"] == "0.0.0.0" ) then
			printCLIError("Enter destination_network_start_ip.")
			return false
		end
	end
	if (configRow["ProtocolBinding.DestinationNetworkType"] == "2")then
		if (configRow["ProtocolBinding.DestinationNetworkEnd"] == nil or configRow["ProtocolBinding.DestinationNetworkEnd"] == "" or configRow["ProtocolBinding.DestinationNetworkEnd"] == "0.0.0.0")then
			printCLIError("Enter destination_network_end_ip.")
			return false
		end
	end
end

function protocolBindingCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "ProtocolBinding"
    if (configRow["ProtocolBinding._ROWID_"] == "-1") then
        errorFlag, statusCode = protocolBinding.config(configRow, "-1", "add")
    else
        errorFlag, statusCode = protocolBinding.config(configRow, configRow["ProtocolBinding._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
    end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    return errorFlag, statusMessage	
end

function protocolBindingModify(args)
    local errorFlag = "Error"
    local statusCode =""
    local statusMessage =""
    DBTable= "ProtocolBinding"     

    configRow= db.getRow("ProtocolBinding","_ROWID_",args[1])
    if (configRow == nil) then
		printCLIError("Row doesn't exist")
		return false
    end
    local rowIds={}
    rowIds["rowId"] = args[1]
    local operation = args[2]
    errorFlag, statusCode = protocolBinding.modifyRules(rowIds, operation)
    if (errorFlag == "OK") then
        db.save()
    end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    return errorFlag, statusMessage
end

function protocolBindingCfgGet()
    local pBTable = db.getTable ("ProtocolBinding")
    local resultTab = {} 
    local configRow = nil
    local rowId = "0"

    printLabel ("List of Protocol Bindings.")    
    for col, val in pairs(pBTable) do
        rowId = rowId+1
        local configRow = pBTable[rowId]
	    if (rowId ~= nil) then
            local srcUser = ''
            local dstUser = ''
	        resTab.insertField (resultTab, "ROW ID", configRow["ProtocolBinding._ROWID_"] or "")
            if (configRow["ProtocolBinding.Enabled"] == "1") then
        	    resTab.insertField (resultTab, "State","Enabled")
            else
        	    resTab.insertField (resultTab, "State","Disabled")
            end
        	resTab.insertField (resultTab, "Service", configRow["ProtocolBinding.ServiceName"] or "")
        	resTab.insertField (resultTab, "Local Gateway", configRow["ProtocolBinding.LocalGateway"] or "")

            if(configRow["ProtocolBinding.SourceNetworkType"] == "0") then
                srcUser = "Any"
            elseif(configRow["ProtocolBinding.SourceNetworkType"] == "1") then
               	srcUser = configRow["ProtocolBinding.SourceNetworkStart"]
	        elseif(configRow["ProtocolBinding.SourceNetworkType"] == "2") then
	            srcUser = configRow["ProtocolBinding.SourceNetworkStart"] .. " - " .. configRow["ProtocolBinding.SourceNetworkEnd"]
            else
                local id = tonumber(configRow["ProtocolBinding.SourceNetworkType"]) - 2
		        srcUser = db.getAttribute("LanGroup","_ROWID_",id,"GroupName")
		        if( srcUser == nil )then
                    srcUser = db.getAttribute ("ipGroup","ipGroupId",configRow["ProtocolBinding.SourceNetworkType"],"ipGroupName") or ''
                end
		    end

            if(configRow["ProtocolBinding.DestinationNetworkType"] == "0") then
                dstUser = "Any"
            elseif(configRow["ProtocolBinding.DestinationNetworkType"] == "1") then
               	dstUser = configRow["ProtocolBinding.DestinationNetworkStart"]
	        elseif(configRow["ProtocolBinding.DestinationNetworkType"] == "2") then
	            dstUser = configRow["ProtocolBinding.DestinationNetworkStart"] .. " - " .. configRow["ProtocolBinding.DestinationNetworkEnd"]
            else
                dstUser = db.getAttribute ("ipGroup","ipGroupId",configRow["ProtocolBinding.DestinationNetworkType"],"ipGroupName") or ''
		    end
            resTab.insertField (resultTab, "Source Network", srcUser)
        	resTab.insertField (resultTab, "Destination Network", dstUser)
        end
    end
    resTab.print (resultTab, 0)
end
