--[[
#### .
#### TeamF1
#### www.TeamF1.com
#### 13 jun , 2012
#### File: siitView.lua
#### Description: SIIT Setup functions
#### Revisions:
01a 13jun12, akr written 
]]--

--package NIMF Configuration
siitView = {}

--function for saving SIIT configuration
function siitView.siitConfigSet (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    local old_configRow = {}
    old_configRow = db.getRow("siitTbl", "rowid", "1")
    if(old_configRow ~= nil)then
	if(inputTable["siitTbl.enable"] == '0')then
		--in case of siit is disabled, save the previous ip address.
		inputTable["siitTbl.ipAddr"] = old_configRow["siitTbl.ipAddr"]
	end
    end
    db.beginTransaction() --begin transaction
    local valid = false
    local isExists = db.existsRow ("siitTbl", "_ROWID_", rowid)
    if (isExists) then
        valid = db.update("siitTbl", inputTable, rowid)
    else
        valid = db.insert("siitTbl", inputTable)        
    end

    -- return    
    if (valid) then
    db.commitTransaction(true)
    return "OK", "STATUS_OK"
    else
    db.rollback()
    return "ERROR", "SIIT_CONFIG_FAILED"
    end    
end

