/* dmz_wan.js - API library for DMZ WAN configuration */

/* Copyright 2011 - 2013 TeamF1, Inc. */

function fwAddDwInServicesValidate ()
    {
    /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Invalid port number- Please enter value between 0 - 65535.';
     var errMsgL10n2 ='Invalid port number:';
     var errMsgL10n3 ='Invalid DMZ server IP address.';
     var errMsgL10n4 ='for octet';
     var errMsgL10n5 ='Invalid DMZ users starting IP address.';
     var errMsgL10n6 ='Invalid DMZ users ending IP address.';
     var errMsgL10n7 ='DMZ Users';
     var errMsgL10n8 ='Invalid WAN users starting IP address.';
     var errMsgL10n9 ='Invalid WAN users ending IP address.';
     var errMsgL10n10 ='WAN Users';    
     /* L10N Error Message Collection End */

	obj = document.getElementById('txtTranslatePortNum');
        if (obj && !obj.disabled)
        {
	if (portValueRangeCheck (obj, 0, 65535, '', null, true, 'Invalid port number.') == false)
        return false;
	}
	if (ipv4AddrOctetsValidate ('tblAddDwInLanServer', 'IPD', false, true,
             errMsgL10n3, errMsgL10n4+" ", true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addDWInLanUserStart', 'IP', false, true,
             errMsgL10n5, errMsgL10n4+" ", true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addDWInLanUserFinish', 'IP', false, true,
             errMsgL10n6, errMsgL10n4+" ", true) == false)
		return false;
	if (ipRangeValidate ('addDWInLanUserStart','addDWInLanUserFinish', errMsgL10n7) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addDWInWanUserStart', 'IP', false, true,
             errMsgL10n8, errMsgL10n4+" ", true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addDWInWanUserFinish', 'IP', false, true,
             errMsgL10n9, errMsgL10n4+" ", true) == false)
		return false;
	if (ipRangeValidate ('addDWInWanUserStart','addDWInWanUserFinish', errMsgL10n10) == false)
		return false;
    showMessage ();

	return true;	
    }
    
function fwActionCheckDW ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHEDULE":
        case "DROP_BY_SCHEDULE":
			fieldStateChangeWr ('','','selSchedule selQos','tblAddDwInLanServer');
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','selQos','tblAddDwInLanServer');
			break;
		default:
			fieldStateChangeWr ('selSchedule selQos','tblAddDwInLanServer','','');
			break;
		}
	/* check for NAT mode */
	var fldObj = document.getElementById('hdNatState');
	if (parseInt (fldObj.value, 10) == 0)	/* CLASSICAL ROUTING */
		fieldStateChangeWr ('', 'tblAddDwInLanServer', '', '');
	}
	    

function dropFieldSelectLanDW (parent)
    {
    if (!parent)
        return;
   	var optVal = document.getElementById (parent.id).value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addDWInLanUserFinish', '', 'addDWInLanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addDWInLanUserStart addDWInLanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addDWInLanUserStart addDWInLanUserFinish', '', '');
   			break;
   		}
	}
function dropFieldSelectWanDW (parent)
    {
    if (!parent)
        return;
   	var optVal = document.getElementById (parent.id).value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addDWInWanUserFinish', '', 'addDWInWanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addDWInWanUserStart addDWInWanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addDWInWanUserStart addDWInWanUserFinish', '', '');
   			break;
   		}
    }

function dropFieldSelectPublicDstAddr ()
    {
    
	var selObj = document.getElementById('selPublicDstIpAddr');
	if (selObj.disable) return;
   	var optVal = selObj.options[selObj.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case 'OTHER':
   			fieldStateChangeWr ('', '', '', 'tblAddDwInPublicDstIpAddr');
   			break;
   		default:
   			fieldStateChangeWr ('', 'tblAddDwInPublicDstIpAddr', '', '');
   			break;
   		}
	}
    
function InitialSettingsDW ()
	{
	fwActionCheckDW ();
	var fldObj = document.getElementById('hdNatState');
	if (parseInt (fldObj.value, 10) == 0)
        fieldStateChangeWr ('chkTranslatePortNum txtTranslatePortNum selPublicDstIpAddr', 'tblAddDwInLanServer', '', '');
	else
		{
		serviceDWCheck ();
		//translatePortNumCheck ();
		//dropFieldSelectPublicDstAddr ();
		fieldStateChangeWr ('addDWInLanUser', 'addDWInLanUserStart addDWInLanUserFinish', '', '');
		}
	
	var fldObj = document.getElementById('addDWInLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLanDW (fldObj);
	var fldObj = document.getElementById('addDWInWanUser');
	if (!(fldObj.disable))
		dropFieldSelectWanDW (fldObj);	
	}

function serviceDWCheck ()
	{
	var selServiceValue = comboSelectedValueGet  ('selDWservice');
	if (!selServiceValue) return;
	switch (selServiceValue)
		{
		case "ANY":
            fieldStateChangeWr ('chkTranslatePortNum txtTranslatePortNum','','','');
			break;
			
		default:
            fieldStateChangeWr ('','','chkTranslatePortNum txtTranslatePortNum','');
            translatePortNumCheck ();
			break;
		}
	}

/* add_dw_in_service.htm End */

/* add_dw_out_service.htm Start */

function fwAddDwOutServicesValidate ()
    {
    /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Invalid starting IP address for DMZ users.';
     var errMsgL10n2 ='for octet';
     var errMsgL10n3 ='Invalid ending IP address for DMZ users.';
     var errMsgL10n4 ='DMZ Users';
     var errMsgL10n5 ='Invalid starting IP address for WAN users.';
     var errMsgL10n6 ='Invalid ending IP address for WAN users.';
     var errMsgL10n7 ='WAN Users';
     var errMsgL10n8 ='Invalid NAT IP address.';
     /* L10N Error Message Collection End */    
     
	if (ipv4AddrOctetsValidate ('addDWOutLanUserStart', 'IP', false, true,
             errMsgL10n1, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addDWOutLanUserFinish', 'IP', false, true,
             errMsgL10n3, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addDWOutLanUserStart','addDWOutLanUserFinish', errMsgL10n4) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addDWOutWanUserStart', 'IP', false, true,
             errMsgL10n5, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addDWOutWanUserFinish', 'IP', false, true,
             errMsgL10n6, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addDWOutWanUserStart','addDWOutWanUserFinish', errMsgL10n7) == false)
		return false;
	//if (ipv4AddrOctetsValidate ('tblNATIPStart', 'IP', false, true,
        //errMsgL10n8, errMsgL10n2+" ", true) == false)
	//return false;
    showMessage ();

    return true;
    }

function showMessage ()
    {
    var selectedValue = comboSelectedValueGet  ('selQos');
    if (!selectedValue) return;
    if (selectedValue == "0") return;
    var preValue = document.getElementById('hd.preQosProfStatus').value;
    if (!preValue) return;
    if (parseInt(preValue, 10) == 1) return;
    var fwRuleStatus = document.getElementById('hd.fwRuleStatus').value;
    if (!fwRuleStatus) return;
    if (parseInt(fwRuleStatus, 10) == 1) 
        alert ('A drop in performance will occur on binding a qos profile to a firewall rule')
    }

function fwActionCheck ()
	{
	var selNATIPObj = document.getElementById ('selNATIP');
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHEDULE":
        case "DROP_BY_SCHEDULE":
			fieldStateChangeWr ('','','selSchedule selQos selNATIP','');
			//dropFieldSelectNAT (selNATIPObj);			
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','','');
			fieldStateChangeWr ('','','selQos selNATIP','');
			//dropFieldSelectNAT (selNATIPObj);			
			break;
		default:
			fieldStateChangeWr ('selSchedule selQos selNATIP','','','');
			break;
		}
		var wanModeObj = document.getElementById('keyNatIpDisable');
	    if(wanModeObj.value == "0")
            fieldStateChangeWr ('selNATIP','', '', '');            
        
   }
	
function dropFieldSelectLan (parent)
    {
    if (!parent)
        return;
   	var optVal = document.getElementById (parent.id).value;   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addDWOutLanUserFinish', '', 'addDWOutLanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addDWOutLanUserStart addDWOutLanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addDWOutLanUserStart addDWOutLanUserFinish', '', '');
   			break;
   		}
	}
function dropFieldSelectWan (parent)
    {
    if (!parent)
        return;
   	var optVal = document.getElementById (parent.id).value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addDWOutWanUserFinish', '', 'addDWOutWanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addDWOutWanUserStart addDWOutWanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addDWOutWanUserStart addDWOutWanUserFinish', '', '');
   			break;
   		}
    }

function dropFieldSelectNAT (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', '', 'selSnat', 'tblNATIPStart');
   			break;
   		default:
   			fieldStateChangeWr ('selSnat', 'tblNATIPStart', '', '');
   			break;
   		}
    }

function InitialSettings ()
	{
	fwActionCheck ();
	var fldObj = document.getElementById('addDWOutLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLan (fldObj);
	var fldObj = document.getElementById('addDWOutWanUser');
	if (!(fldObj.disable))
		dropFieldSelectWan (fldObj);
	//var fldObj = document.getElementById('selNATIP');
	//if (!(fldObj.disable))
		//dropFieldSelectNAT (fldObj);	
	}

function wanModeCheck ()
{
	var wanModeObj = document.getElementById('keyNatIpDisable');
	if(wanModeObj.value == "0")
            fieldStateChangeWr ('selNATIP','', '', '');
	var primWanObj = document.getElementById('hdPrimWan');            
	if (primWanObj.value == "0")
	{
		primWanObj.value = 1;
		optionValueSelect ('selSnat', 'hdPrimWan');            		
		primWanObj.value = 0;
	}
	else if (primWanObj.value == "1")
	{
		primWanObj.value = 2;
		optionValueSelect ('selSnat', 'hdPrimWan');            		
		primWanObj.value = 1;
	}
}

